# КонтейнерАннотаций

## ПриСозданииОбъекта

```bsl
// Контейнер аннотаций - объект, который хранит все определения аннотаций.
// При создании контейнера аннотаций в него автоматически добавляется базовая аннотация &Аннотация.
//
Процедура ПриСозданииОбъекта() 
```

## ПолучитьОпределенияАннотаций

```bsl
// Получить все определения аннотаций.
//
//  Возвращаемое значение:
//   ФиксированноеСоответствие - Соответствие, в котором хранятся все определения аннотаций:
//	   * Ключ - Строка - имя аннотации.
//	   * Значение - ОпределениеАннотации - определение аннотации.
//
Функция ПолучитьОпределенияАннотаций() Экспорт
```

## ПолучитьОпределениеАннотации

```bsl
// Получить определение аннотации по её имени.
//
// Параметры:
//   Имя - Строка - Имя аннотации.
//
//  Возвращаемое значение:
//   ОпределениеАннотации, Неопределено - Найденное определение аннотаций. 
//                                        Неопределено, если аннотация с данным именем не зарегистрирована.
//
Функция ПолучитьОпределениеАннотации(Имя) Экспорт
```

## ПолучитьРазворачивательАннотаций

```bsl
// Получить настроенный разворачиватель аннотаций.
//
//  Возвращаемое значение:
//   РазворачивательАннотаций - Разворачиватель аннотаций, связанный с данным контейнером аннотаций.
//
Функция ПолучитьРазворачивательАннотаций() Экспорт
```

## ДобавитьАннотацию

```bsl
// Добавить аннотацию в контейнер аннотаций.
//
// Параметры:
//   ТипАннотации - Тип - Тип аннотации.
//
//  Возвращаемое значение:
//   ОпределениеАннотации - Определение добавленной аннотации.
//
Функция ДобавитьАннотацию(ТипАннотации) Экспорт
```

