# РаботаСАннотациями

## ПолучитьАннотации

```bsl
// Получить все аннотации свойства с указанным именем аннотации.
//
// Параметры:
//   Свойство - СтрокаТабличнойЧасти, Структура - Описание свойства/метода:
//	   * Аннотации - ТаблицаЗначений - Таблица аннотаций свойства/метода:
//		   * Имя - Строка - Имя аннотации.
//   ИмяАннотации - Строка - Имя аннотации.
//
//  Возвращаемое значение:
//   Массив из СтрокаТабличнойЧасти - Массив найденных аннотаций.
//
Функция ПолучитьАннотации(Свойство, ИмяАннотации) 
```

## ПолучитьАннотацию

```bsl
// Получить первую аннотацию свойства с указанным именем аннотации.
//
// Параметры:
//   Свойство - СтрокаТабличнойЧасти, Структура - Описание свойства/метода:
//	   * Аннотации - ТаблицаЗначений - Таблица аннотаций свойства/метода:
//		   * Имя - Строка - Имя аннотации.
//   ИмяАннотации - Строка - Имя аннотации.
//
//  Возвращаемое значение:
//   СтрокаТабличнойЧасти - Найденная аннотация.
//
Функция ПолучитьАннотацию(Свойство, ИмяАннотации) 
```

## НайтиАннотации

```bsl
// Получить все аннотации с указанным именем аннотации.
//
// Параметры:
//   Аннотации - ТаблицаЗначений - Таблица аннотаций:
//	   * Имя - Строка - Имя аннотации.
//   ИмяАннотации - Строка - Имя аннотации.
//
//  Возвращаемое значение:
//   Массив из СтрокаТабличнойЧасти - Массив найденных аннотаций.
//
Функция НайтиАннотации(Аннотации, ИмяАннотации) 
```

## НайтиАннотацию

```bsl
// Получить первую аннотацию с указанным именем аннотации.
//
// Параметры:
//   Аннотации - ТаблицаЗначений - Таблица аннотаций:
//	   * Имя - Строка - Имя аннотации.
//   ИмяАннотации - Строка - Имя аннотации.
//
//  Возвращаемое значение:
//   СтрокаТабличнойЧасти - Найденная аннотация.
//
Функция НайтиАннотацию(Аннотации, ИмяАннотации) 
```

## НайтиМетодыСАннотацией

```bsl
// Получить все методы с указанной аннотацией.
//
// Параметры:
//   Методы - ТаблицаЗначений, Массив - Список методов:
//	   * Аннотации - ТаблицаЗначений - Таблица аннотаций метода:
//		   * Имя - Строка - Имя аннотации.
//   ИмяАннотации - Строка - Имя аннотации.
//
//  Возвращаемое значение:
//   Массив из СтрокаТабличнойЧасти - Массив найденных методов.
//
Функция НайтиМетодыСАннотацией(Методы, ИмяАннотации) 
```

## ПолучитьПараметрыАннотации

```bsl
// Получить параметры аннотации с указанным именем параметра.
//
// Параметры:
//   Аннотация - СтрокаТабличнойЧасти,Структура - Аннотация:
//	   * Параметры - ТаблицаЗначений - Таблица параметров аннотации:
//		   * Имя - Строка - Имя параметра.
//   ИмяПараметра - Строка - Имя параметра.
//
//  Возвращаемое значение:
//   Массив из СтрокаТабличнойЧасти - Массив найденных параметров.
//
Функция ПолучитьПараметрыАннотации(Аннотация, ИмяПараметра) 
```

## ПолучитьПараметрАннотации

```bsl
// Получить параметр аннотации с указанным именем параметра.
//
// Параметры:
//   Аннотация - СтрокаТабличнойЧасти,Структура - Аннотация:
//	   * Параметры - ТаблицаЗначений - Таблица параметров аннотации:
//		   * Имя - Строка - Имя параметра.
//   ИмяПараметра - Строка - Имя параметра.
//
//  Возвращаемое значение:
//   СтрокаТабличнойЧасти - Найденный параметр.
//
Функция ПолучитьПараметрАннотации(Аннотация, ИмяПараметра) 
```

## ПолучитьЗначенияПараметровАннотации

```bsl
// Получить значения параметров аннотации с указанным именем параметра.
//
// Параметры:
//   Аннотация - СтрокаТабличнойЧасти,Структура - Аннотация:
//	   * Параметры - ТаблицаЗначений - Таблица параметров аннотации:
//		   * Имя - Строка - Имя параметра.
//         * Значение - Произвольный - Значение параметра.
//   ИмяПараметра - Строка - Имя параметра.
//
//  Возвращаемое значение:
//   Массив из Произвольный - Массив найденных значений параметров.
//
Функция ПолучитьЗначенияПараметровАннотации(Аннотация, ИмяПараметра) 
```

## ПолучитьЗначениеПараметраАннотации

```bsl
// Получить значение параметра аннотации с указанным именем параметра.
//
// Параметры:
//   Аннотация - СтрокаТабличнойЧасти,Структура - Аннотация:
//	   * Параметры - ТаблицаЗначений - Таблица параметров аннотации:
//		   * Имя - Строка - Имя параметра.
//         * Значение - Произвольный - Значение параметра.
//   ИмяПараметра - Строка - Имя параметра.
//   ЗначениеПоУмолчанию - Произвольный - Значение параметра по умолчанию.
//   НеопределеноЭтоКорректноеЗначениеПараметра - Булево - Признак того,
//                                                         что Неопределено является корректным значением параметра.
//
//  Возвращаемое значение:
//   Произвольный - Значение параметра.
//
Функция ПолучитьЗначениеПараметраАннотации(Аннотация, ИмяПараметра = "Значение", ЗначениеПоУмолчанию = Неопределено, НеопределеноЭтоКорректноеЗначениеПараметра = Ложь) 
```

## УстановитьЗначениеПараметраАннотации

```bsl
// Установить значение параметра аннотации с указанным именем параметра.
//
// Параметры:
//   Аннотация - СтрокаТабличнойЧасти,Структура - Аннотация:
//	   * Параметры - ТаблицаЗначений - Таблица параметров аннотации:
//		   * Имя - Строка - Имя параметра.
//         * Значение - Произвольный - Значение параметра.
//   ИмяПараметра - Строка - Имя параметра.
//   ЗначениеПараметра - Произвольный - Значение параметра.
//
Процедура УстановитьЗначениеПараметраАннотации(Аннотация, ИмяПараметра, ЗначениеПараметра) 
```
